#pragma once

#include "PreCompiledHeaders.hh"
#include "Lib/Ass/Style.hh"

namespace Vivy::Ass
{
// Overrides some properties of the Style of an Ass::Line, Ass::Char, Ass::Syl

struct StyleProperties final {
    QString name{ "Default" };

    // Colors
    QColor primaryColor{ Color::defaultValue }, secondaryColor{ Color::defaultValue },
        outlineColor{ Color::defaultValue }, backColor{ Color::defaultValue };

    QString fontName{}; // Can override the font's name
    int fontSize{};     // The font size != the font scaling

    bool bold{ false }, italic{ false }, underline{ false }, strikeOut{ false };

    // Usefull for rotations
    float angle{ 0.0 };

    // No margin by default
    int marginL{ 0 }, marginR{ 0 }, marginV{ 0 };

    float scaleX{ 0.0 }, scaleY{ 0.0 };  // Font scaling
    float outline{ 0.0 }, shadow{ 0.0 }; // Outline sizes

    // Alignement is bottom center
    int alignment{ 2 };
};
}
