mod aux_table;
mod line;
mod syllabe;

pub use self::{aux_table::*, line::*, syllabe::*};

use crate::{definitions::ScriptInfoKey, ASSStyle};
use std::{collections::HashMap, fs, io};

#[derive(Debug, Clone)]
pub struct ASSContainer<T: AuxTable> {
    pub lines: Vec<ASSLine<T>>,
    pub script_info: HashMap<ScriptInfoKey, String>,
    pub styles: HashMap<String, ASSStyle>,
}

impl<T: AuxTable> ASSContainer<T> {
    /// Create an ASS container from its parts, they must be valide!
    #[inline]
    pub(crate) fn from_parts(
        lines: impl IntoIterator<Item = ASSLine<T>>,
        script_info: HashMap<ScriptInfoKey, String>,
        styles: HashMap<String, ASSStyle>,
    ) -> Self {
        Self { lines: lines.into_iter().collect(), script_info, styles }
    }

    /// Write the content of the container into a file as an ASS file.
    pub fn write_ass_to_file(&self, _: &mut fs::File) -> io::Result<()> {
        todo!()
    }
}
