use crate::{ASSPosition, AuxTable};

#[derive(Debug, Default, PartialEq)]
pub struct ASSSyllabe<T: AuxTable> {
    pub position: ASSPosition,
    pub content: String,
    pub aux: T,
    pub start: i32,
    pub fini: i32,
}

impl<T: AuxTable> Clone for ASSSyllabe<T> {
    fn clone(&self) -> Self {
        let Self { position, start, fini, .. } = *self;
        let content = self.content.clone();
        let aux = self.aux.deep_clone();
        Self { position, content, aux, start, fini }
    }
}
