use crate::{library::*, passes::declare_pass};
use vvs_parser::prelude::*;

declare_pass! {
    /// Collector of custom type, to register them in the library.
    #[allow(dead_code)]
    visit::TypeCollector: 'a {}

    aux { library: &'a mut Library }
}

impl ast::Visitor for TypeCollector<'_> {
    fn visit_type_declaration_end(&mut self, decl: &ast::TypeDeclaration) {
        self.error(decl.type_token(), "custom type are tbd")
    }
}
