// Consumes a ParserResult into an Option<T>.
// If the ParserResult is LexerMoved, this signifies an unrecoverable error, and
// the function exits early.
// I wish we had Try traits.
#[doc(hidden)]
#[macro_export]
macro_rules! try_parser {
    ($result:expr) => {{
        use $crate::ast::parsers::ParserResult;
        match $result {
            ParserResult::Value(value) => Some(value),
            ParserResult::NotFound => None,
            ParserResult::LexerMoved => return ParserResult::LexerMoved,
        }
    }};
}
