use super::*;
use std::mem::size_of;

#[test]
fn nil_and_options() {
    let nil = unsafe { VVRTAny_nil() };
    assert_eq!(nil.ty(), VVRTType::Nil, "invalid type");
    assert_eq!(size_of::<VVRTType>(), size_of::<Option<VVRTType>>());
}

#[test]
fn any_integer() {
    unsafe {
        let zero = Into::<VVRTAny>::into(0i32);
        assert!(VVRTAny_is_ty(zero, VVRTType::Number));
        assert!(!zero.number_is_f32());
        assert!(zero.number_is_i32());
        assert_eq!(VVRTAny_as_integer(zero), 0);
        assert_eq!(VVRTAny_as_floating(zero), 0.0);

        let zero = Into::<VVRTAny>::into(0f32);
        assert!(VVRTAny_is_ty(zero, VVRTType::Number));
        assert!(zero.number_is_f32());
        assert!(!zero.number_is_i32());
        assert_eq!(VVRTAny_as_integer(zero), 0);
        assert_eq!(VVRTAny_as_floating(zero), 0.0);

        assert!(VVRTAny_ne(Into::<VVRTAny>::into(0f32), Into::<VVRTAny>::into(0i32)));
    }
}
