#pragma once

#include "PreCompiledHeaders.hh"
#include "VivyApplication.hh"
#include "Lib/Utils.hh"
#include "Lib/Log.hh"

namespace Vivy
{
class AboutWindow final : public QMainWindow {
    Q_OBJECT
    VIVY_APP_LOGGABLE_OBJECT(AboutWindow, logger)

    QTabWidget *panels;

    // Simple QLabel with some presets
    class SimpleLabel final : public QLabel {
    public:
        explicit SimpleLabel(QWidget *parent, const char *text);
        ~SimpleLabel() noexcept override;
    };

    // Simple QLabel for licences
    class LicenceLabel final : public QTextEdit {
        VIVY_APP_LOGGABLE_OBJECT(LicenceLabel, logger)
    public:
        explicit LicenceLabel(QWidget *parent, const QString &url, const Qt::TextFormat format);
        ~LicenceLabel() noexcept override;
    };

public:
    explicit AboutWindow(QWidget *parent) noexcept;
    ~AboutWindow() noexcept override = default;

signals:
    void closed();

private:
    void closeEvent(QCloseEvent *bar) noexcept override;
};
}
