#include "PreCompiledHeaders.hh"
#include "UI/DockWidgetTitleBar.hh"

using namespace Vivy;

DockWidgetTitleBar::DockWidgetTitleBar(QDockWidget *parent) noexcept
    : QWidget(parent)
    , attachedDock(parent)
{
    if (parent == nullptr)
        logFatal() << "Can't pass a nullptr as a parent widget pointer";

    const QString name = parent->windowTitle();
    auto *const box    = new QHBoxLayout(this);
    box->addWidget(new QLabel(name, this));
    qobject_cast<QHBoxLayout *>(layout())->setStretch(0, 1);
    VIVY_LOG_CTOR() << "TitleBar added to dock " << VIVY_LOG_QUOTED(name);
}

void
DockWidgetTitleBar::addToDock(QDockWidget *const dock) noexcept
{
    DockWidgetTitleBar *const titleBar = new DockWidgetTitleBar(dock);
    titleBar->logDebug() << "Adding " << VIVY_LOG_QUOTED(dock->windowTitle()) << " to dock...";
    Utils::setTransparentBackgroundForWidget(titleBar);
    dock->setTitleBarWidget(titleBar);
}
