#include "PreCompiledHeaders.hh"
#include "UI/Utils.hh"

using namespace Vivy;

void
Utils::setTransparentBackgroundForWidget(QWidget *const w) noexcept
{
    w->setAttribute(Qt::WA_NoSystemBackground);
    w->setAttribute(Qt::WA_TranslucentBackground);
    w->setAttribute(Qt::WA_TransparentForMouseEvents);
}

const QString Utils::untouchedTabIndicator = QStringLiteral("(*)");
const QString Utils::unsavedTabIndicator   = QStringLiteral("(+)");

void
Utils::deleteInternalWidget(QDockWidget *const dock) noexcept
{
    QWidget *widget = dock->widget();
    if (widget != nullptr) {
        delete widget;
        dock->setWidget(nullptr);
    }
}
